# bundle.mak
#
# Copyright (C) 1995, 1996, 1997 Ovidiu Predescu and Mircea Oancea.
# All rights reserved.
#
# Author: Mircea Oancea <mircea@jupiter.elcom.pub.ro>
#
# This file is part of libFoundation.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted, provided
# that the above copyright notice appear in all copies and that both that
# copyright notice and this permission notice appear in supporting
# documentation.
#
# We disclaim all warranties with regard to this software, including all
# implied warranties of merchantability and fitness, in no event shall
# we be liable for any special, indirect or consequential damages or any
# damages whatsoever resulting from loss of use, data or profits, whether in
# an action of contract, negligence or other tortious action, arising out of
# or in connection with the use or performance of this software.

BUNDLE_AVAIL	= no
LDPROG		= $(CC)

ifeq ($(HOST_OS), nextstep3)
ifeq ($(OBJC_RUNTIME), NeXT)
BUNDLE_AVAIL	= yes
BUNDLE_CFLAGS	=
BUNDLE_LDFLAGS	= -r
BUNDLE_LD	= ld
endif # NeXT runtime
endif # nextstep3

ifeq ($(findstring linux, $(HOST_OS)), linux)
BUNDLE_AVAIL	= yes
BUNDLE_CFLAGS	= -fPIC
BUNDLE_LDFLAGS	= -shared
BUNDLE_LD	= $(CC) -shared
LDFLAGS		:= $(LDFLAGS) -rdynamic
endif # linux

ifeq ($(HOST_OS), solaris2)
BUNDLE_AVAIL	= yes
BUNDLE_CFLAGS	= -fPIC
BUNDLE_LDFLAGS	= -shared
BUNDLE_LD	= $(CC) -shared
LDFLAGS		:= $(LDFLAGS) -Wl,-G
endif # solaris2

