# environment variables to configure Alloc Debug behaviour
# usage from bash shell: source allocdebug.env 
# or . allocdebug.env 

# must be set to something to use alloc debug zone
set environment  ALLOCDEBUG YES

# stop in debugger (SIGINT) when alloc-ing pointer number *
# nil or 0 means no stop
set environment  ALLOCDEBUG_STOP 0

# stop in debugger (SIGINT) when alloc-ing pointer number *
# nil or 0 means no stop
set environment  ALLOCDEBUG_MARK 0

# number of passes inside allocation/deallocation functions
# to SYSTEM_MALLOC_CHECK and internal check
# nil or 0 means no checks
set environment  ALLOCDEBUG_COUNT 1

# number of bytes to alloc at top/bottom of object block
# these bytes are set to a given value (0x88) and checked
# at free and internal check to guard against using memory
# past the limit.
set environment  ALLOCDEBUG_UPPER 4
set environment  ALLOCDEBUG_LOWER 4

# Print variables

show environment  ALLOCDEBUG
show environment  ALLOCDEBUG_MARK
show environment  ALLOCDEBUG_STOP
show environment  ALLOCDEBUG_COUNT
show environment  ALLOCDEBUG_UPPER
show environment  ALLOCDEBUG_LOWER
