/* 
   functions.m

   Copyright (C) 1995, 1996, 1997 Ovidiu Predescu and Mircea Oancea.
   All rights reserved.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>

   This file is part of libFoundation.

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/

#ifndef __functions_h__
#define __functions_h__

#include <ObjCTest/tests.h>
#include <config.h>

void try_catch1(void);
void try_catch2(void);
void nsduring_nshandler(void);

#ifndef NO_NESTED_FUNCTIONS
void try_multicatch(void);
void try_cleanup_catch1(void);
void try_cleanup_catch2(void);
void try_finally_catch1(void);
void try_finally_catch2(void);
void try_cleanup_nocatch(void);
void try_finally_nocatch(void);
void try_cleanup_finally_nocatch(void);
void try_cleanup_cleanup_finally_nocatch(void);
#endif



void invocation_setFlag(id object);
void invocation_setShortValue(id object);
void invocation_setIntValue(id object);
void invocation_setString(id object);
void invocation_setIntFloatDoubleValues(id object);
void invocation_setStruct1(id object);
void invocation_setStruct2(id object);
void invocation_setStruct3(id object);
void invocation_setStruct4(id object);
void invocation_setStruct5(id object);
void invocation_setStruct6(id object);
void invocation_setStruct7(id object);
void invocation_setStruct8(id object);
void invocation_setStruct9(id object);
void invocation_setStruct10(id object);
void invocation_setStruct11(id object);
void invocation_setStruct12(id object);
void invocation_setStruct13(id object);
void invocation_setStruct14(id object);
void invocation_setStruct15(id object);
void invocation_setStruct16(id object);
void invocation_flag(id object);
void invocation_shortValue(id object);
void invocation_intValue(id object);
void invocation_floatValue(id object);
void invocation_doubleValue(id object);
void invocation_string(id object);
void invocation_struct1(id object);
void invocation_struct2(id object);
void invocation_struct3(id object);
void invocation_struct4(id object);
void invocation_struct5(id object);
void invocation_struct6(id object);
void invocation_struct7(id object);
void invocation_struct8(id object);
void invocation_struct9(id object);
void invocation_struct10(id object);
void invocation_struct11(id object);
void invocation_struct12(id object);
void invocation_struct13(id object);
void invocation_struct14(id object);
void invocation_struct15(id object);
void invocation_struct16(id object);

void string_format_char(id string, id format);
void string_format_short(id string, id format);
void string_format_int(id string, id format);
void string_format_float(id string, id format);
void string_format_cstring(id string, id format);
void string_format_obj(id string, id format);
void string_format_char_int(id string, id format);
void string_format_short_int(id string, id format);
void string_format_int_int(id string, id format);
void string_format_float_int(id string, id format);
void string_format_cstring_int(id string, id format);
void string_format_obj_int(id string, id format);

char* cstringcopy(char* cstr, int length);

void forwarder_setFlag(id object);
void forwarder_setShortValue(id object);
void forwarder_setIntValue(id object);
void forwarder_setIntFloatDoubleValues(id object);
void forwarder_flag(id object);
void forwarder_shortValue(id object);
void forwarder_intValue(id object);
void forwarder_floatValue(id object);
void forwarder_doubleValue(id object);
void forwarder_struct1(id object);
void forwarder_struct2(id object);
void forwarder_struct3(id object);
void forwarder_struct4(id object);
void forwarder_struct5(id object);
void forwarder_struct6(id object);
void forwarder_struct7(id object);
void forwarder_struct8(id object);
void forwarder_struct9(id object);
void forwarder_struct10(id object);
void forwarder_struct11(id object);
void forwarder_struct12(id object);
void forwarder_struct13(id object);
void forwarder_struct14(id object);
void forwarder_struct15(id object);
void forwarder_struct16(id object);
void forwarder_setStruct1(id object);
void forwarder_setStruct2(id object);
void forwarder_setStruct3(id object);
void forwarder_setStruct4(id object);
void forwarder_setStruct5(id object);
void forwarder_setStruct6(id object);
void forwarder_setStruct7(id object);
void forwarder_setStruct8(id object);
void forwarder_setStruct9(id object);
void forwarder_setStruct10(id object);
void forwarder_setStruct11(id object);
void forwarder_setStruct12(id object);
void forwarder_setStruct13(id object);
void forwarder_setStruct14(id object);
void forwarder_setStruct15(id object);
void forwarder_setStruct16(id object);
void setReturnValue_flag(id invocation);
void setReturnValue_shortValue(id invocation);
void setReturnValue_intValue(id invocation);
void setReturnValue_floatValue(id invocation);
void setReturnValue_doubleValue(id invocation);
void setReturnValue_struct1(id invocation);
void setReturnValue_struct2(id invocation);
void setReturnValue_struct3(id invocation);
void setReturnValue_struct4(id invocation);
void setReturnValue_struct5(id invocation);
void setReturnValue_struct6(id invocation);
void setReturnValue_struct7(id invocation);
void setReturnValue_struct8(id invocation);
void setReturnValue_struct9(id invocation);
void setReturnValue_struct10(id invocation);
void setReturnValue_struct11(id invocation);
void setReturnValue_struct12(id invocation);
void setReturnValue_struct13(id invocation);
void setReturnValue_struct14(id invocation);
void setReturnValue_struct15(id invocation);
void setReturnValue_struct16(id invocation);

/* Register all functions used in these tests */
void
init_test()
{
  /* Functions with no parameters */
  register_function_with_name(try_catch1, "try_catch1");
  register_function_with_name(try_catch2, "try_catch2");
  register_function_with_name(nsduring_nshandler, "nsduring_nshandler");
#ifndef NO_NESTED_FUNCTIONS
  register_function_with_name(try_multicatch, "try_multicatch");
  register_function_with_name(try_cleanup_catch1, "try_cleanup_catch1");
  register_function_with_name(try_cleanup_catch2, "try_cleanup_catch2");
  register_function_with_name(try_finally_catch1, "try_finally_catch1");
  register_function_with_name(try_finally_catch2, "try_finally_catch2");
  register_function_with_name(try_cleanup_nocatch, "try_cleanup_nocatch");
  register_function_with_name(try_cleanup_finally_nocatch,
			      "try_cleanup_finally_nocatch");
  register_function_with_name(try_finally_nocatch, "try_finally_nocatch");
  register_function_with_name(try_cleanup_cleanup_finally_nocatch,
			      "try_cleanup_cleanup_finally_nocatch");
#endif

  /* Functions with one parameter */
  register_function1_with_name(invocation_setFlag, "invocation_setFlag");
  register_function1_with_name(invocation_setShortValue,
			       "invocation_setShortValue");
  register_function1_with_name(invocation_setIntValue,
			       "invocation_setIntValue");
  register_function1_with_name(invocation_setString, "invocation_setString");
  register_function1_with_name(invocation_setIntFloatDoubleValues,
			       "invocation_setIntFloatDoubleValues");
  register_function1_with_name(invocation_setStruct1,
			       "invocation_setStruct1");
  register_function1_with_name(invocation_setStruct2,
			       "invocation_setStruct2");
  register_function1_with_name(invocation_setStruct3,
			       "invocation_setStruct3");
  register_function1_with_name(invocation_setStruct4,
			       "invocation_setStruct4");
  register_function1_with_name(invocation_setStruct5,
			       "invocation_setStruct5");
  register_function1_with_name(invocation_setStruct6,
			       "invocation_setStruct6");
  register_function1_with_name(invocation_setStruct7,
			       "invocation_setStruct7");
  register_function1_with_name(invocation_setStruct8,
			       "invocation_setStruct8");
  register_function1_with_name(invocation_setStruct9,
			       "invocation_setStruct9");
  register_function1_with_name(invocation_setStruct10,
			       "invocation_setStruct10");
  register_function1_with_name(invocation_setStruct11,
			       "invocation_setStruct11");
  register_function1_with_name(invocation_setStruct12,
			       "invocation_setStruct12");
  register_function1_with_name(invocation_setStruct13,
			       "invocation_setStruct13");
  register_function1_with_name(invocation_setStruct14,
			       "invocation_setStruct14");
  register_function1_with_name(invocation_setStruct15,
			       "invocation_setStruct15");
  register_function1_with_name(invocation_setStruct16,
			       "invocation_setStruct16");
  register_function1_with_name(invocation_flag, "invocation_flag");
  register_function1_with_name(invocation_shortValue,
			       "invocation_shortValue");
  register_function1_with_name(invocation_intValue,
			       "invocation_intValue");
  register_function1_with_name(invocation_floatValue,
			       "invocation_floatValue");
  register_function1_with_name(invocation_doubleValue,
			       "invocation_doubleValue");
  register_function1_with_name(invocation_string,
			       "invocation_string");
  register_function1_with_name(invocation_struct1,
			       "invocation_struct1");
  register_function1_with_name(invocation_struct2,
			       "invocation_struct2");
  register_function1_with_name(invocation_struct3,
			       "invocation_struct3");
  register_function1_with_name(invocation_struct4,
			       "invocation_struct4");
  register_function1_with_name(invocation_struct5,
			       "invocation_struct5");
  register_function1_with_name(invocation_struct6,
			       "invocation_struct6");
  register_function1_with_name(invocation_struct7,
			       "invocation_struct7");
  register_function1_with_name(invocation_struct8,
			       "invocation_struct8");
  register_function1_with_name(invocation_struct9,
			       "invocation_struct9");
  register_function1_with_name(invocation_struct10,
			       "invocation_struct10");
  register_function1_with_name(invocation_struct11,
			       "invocation_struct11");
  register_function1_with_name(invocation_struct12,
			       "invocation_struct12");
  register_function1_with_name(invocation_struct13,
			       "invocation_struct13");
  register_function1_with_name(invocation_struct14,
			       "invocation_struct14");
  register_function1_with_name(invocation_struct15,
			       "invocation_struct15");
  register_function1_with_name(invocation_struct16,
			       "invocation_struct16");

  register_function1_with_name(forwarder_setFlag,
			       "forwarder_setFlag");
  register_function1_with_name(forwarder_setShortValue,
			       "forwarder_setShortValue");
  register_function1_with_name(forwarder_setIntValue,
			       "forwarder_setIntValue");
  register_function1_with_name(forwarder_setIntFloatDoubleValues,
			       "forwarder_setIntFloatDoubleValues");
  register_function1_with_name(forwarder_flag,
			       "forwarder_flag");
  register_function1_with_name(forwarder_shortValue,
			       "forwarder_shortValue");
  register_function1_with_name(forwarder_intValue,
			       "forwarder_intValue");
  register_function1_with_name(forwarder_floatValue,
			       "forwarder_floatValue");
  register_function1_with_name(forwarder_doubleValue,
			       "forwarder_doubleValue");
  register_function1_with_name(forwarder_struct1,
			       "forwarder_struct1");
  register_function1_with_name(forwarder_struct2,
			       "forwarder_struct2");
  register_function1_with_name(forwarder_struct3,
			       "forwarder_struct3");
  register_function1_with_name(forwarder_struct4,
			       "forwarder_struct4");
  register_function1_with_name(forwarder_struct5,
			       "forwarder_struct5");
  register_function1_with_name(forwarder_struct6,
			       "forwarder_struct6");
  register_function1_with_name(forwarder_struct7,
			       "forwarder_struct7");
  register_function1_with_name(forwarder_struct8,
			       "forwarder_struct8");
  register_function1_with_name(forwarder_struct9,
			       "forwarder_struct9");
  register_function1_with_name(forwarder_struct10,
			       "forwarder_struct10");
  register_function1_with_name(forwarder_struct11,
			       "forwarder_struct11");
  register_function1_with_name(forwarder_struct12,
			       "forwarder_struct12");
  register_function1_with_name(forwarder_struct13,
			       "forwarder_struct13");
  register_function1_with_name(forwarder_struct14,
			       "forwarder_struct14");
  register_function1_with_name(forwarder_struct15,
			       "forwarder_struct15");
  register_function1_with_name(forwarder_struct16,
			       "forwarder_struct16");
  register_function1_with_name(forwarder_setStruct1,
			       "forwarder_setStruct1");
  register_function1_with_name(forwarder_setStruct2,
			       "forwarder_setStruct2");
  register_function1_with_name(forwarder_setStruct3,
			       "forwarder_setStruct3");
  register_function1_with_name(forwarder_setStruct4,
			       "forwarder_setStruct4");
  register_function1_with_name(forwarder_setStruct5,
			       "forwarder_setStruct5");
  register_function1_with_name(forwarder_setStruct6,
			       "forwarder_setStruct6");
  register_function1_with_name(forwarder_setStruct7,
			       "forwarder_setStruct7");
  register_function1_with_name(forwarder_setStruct8,
			       "forwarder_setStruct8");
  register_function1_with_name(forwarder_setStruct9,
			       "forwarder_setStruct9");
  register_function1_with_name(forwarder_setStruct10,
			       "forwarder_setStruct10");
  register_function1_with_name(forwarder_setStruct11,
			       "forwarder_setStruct11");
  register_function1_with_name(forwarder_setStruct12,
			       "forwarder_setStruct12");
  register_function1_with_name(forwarder_setStruct13,
			       "forwarder_setStruct13");
  register_function1_with_name(forwarder_setStruct14,
			       "forwarder_setStruct14");
  register_function1_with_name(forwarder_setStruct15,
			       "forwarder_setStruct15");
  register_function1_with_name(forwarder_setStruct16,
			       "forwarder_setStruct16");

  register_function1_with_name(setReturnValue_flag,
			       "setReturnValue_flag");
  register_function1_with_name(setReturnValue_shortValue,
			       "setReturnValue_shortValue");
  register_function1_with_name(setReturnValue_intValue,
			       "setReturnValue_intValue");
  register_function1_with_name(setReturnValue_floatValue,
			       "setReturnValue_floatValue");
  register_function1_with_name(setReturnValue_doubleValue,
			       "setReturnValue_doubleValue");
  register_function1_with_name(setReturnValue_struct1,
			       "setReturnValue_struct1");
  register_function1_with_name(setReturnValue_struct2,
			       "setReturnValue_struct2");
  register_function1_with_name(setReturnValue_struct3,
			       "setReturnValue_struct3");
  register_function1_with_name(setReturnValue_struct4,
			       "setReturnValue_struct4");
  register_function1_with_name(setReturnValue_struct5,
			       "setReturnValue_struct5");
  register_function1_with_name(setReturnValue_struct6,
			       "setReturnValue_struct6");
  register_function1_with_name(setReturnValue_struct7,
			       "setReturnValue_struct7");
  register_function1_with_name(setReturnValue_struct8,
			       "setReturnValue_struct8");
  register_function1_with_name(setReturnValue_struct9,
			       "setReturnValue_struct9");
  register_function1_with_name(setReturnValue_struct10,
			       "setReturnValue_struct10");
  register_function1_with_name(setReturnValue_struct11,
			       "setReturnValue_struct11");
  register_function1_with_name(setReturnValue_struct12,
			       "setReturnValue_struct12");
  register_function1_with_name(setReturnValue_struct13,
			       "setReturnValue_struct13");
  register_function1_with_name(setReturnValue_struct14,
			       "setReturnValue_struct14");
  register_function1_with_name(setReturnValue_struct15,
			       "setReturnValue_struct15");
  register_function1_with_name(setReturnValue_struct16,
			       "setReturnValue_struct16");

  /* Functions with two parameters */
  register_function2_with_name(string_format_char, "string_format_char");
  register_function2_with_name(string_format_short, "string_format_short");
  register_function2_with_name(string_format_int, "string_format_int");
  register_function2_with_name(string_format_float, "string_format_float");
  register_function2_with_name(string_format_cstring, "string_format_cstring");
  register_function2_with_name(string_format_obj, "string_format_obj");
  register_function2_with_name(string_format_char_int,
			       "string_format_char_int");
  register_function2_with_name(string_format_short_int,
			       "string_format_short_int");
  register_function2_with_name(string_format_int_int,
			       "string_format_int_int");
  register_function2_with_name(string_format_float_int,
			       "string_format_float_int");
  register_function2_with_name(string_format_cstring_int,
			       "string_format_cstring_int");
  register_function2_with_name(string_format_obj_int,
			       "string_format_obj_int");
};

#endif /* __functions_h__ */
