/* 
   linking.m

   Copyright (C) 1995, 1996, 1997 Ovidiu Predescu and Mircea Oancea.
   All rights reserved.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>

   This file is part of libFoundation.

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/

#import <Foundation/NSRunLoop.h>
#import <Foundation/NSUserDefaults.h>

#if GNUSTEP_BASE_LIBRARY || LIBOBJECTS_LIBRARY
# include <gnustep/base/RunLoop.h>
#endif

#if LIB_FOUNDATION_LIBRARY
# import <Foundation/StackZone.h>
#endif

#if !GNUSTEP_BASE_LIBRARY
# import <Foundation/NSFileHandle.h>
# import <Foundation/NSTask.h>
#endif

#import <Foundation/NSDictionary.h>
#import <Foundation/NSMethodSignature.h>
#import <Foundation/NSArchiver.h>
#import <Foundation/NSBundle.h>
#import <Foundation/NSCharacterSet.h>
#import <Foundation/NSScanner.h>
#import <Foundation/NSScanner.h>
#import <Foundation/NSData.h>

#include <extensions/GCArray.h>
#include <extensions/GCDictionary.h>

static void __dummy(void)
{
    [NSDictionary new];
    [NSArchiver new];
    [GCArray new];
    [GCDictionary new];
    [NSMethodSignature new];
    [NSBundle new];
    [NSCharacterSet new];
    [NSScanner new];
    [NSData new];
    [NSUserDefaults new];
    [NSRunLoop new];
    [NSFileHandle new];

#if LIB_FOUNDATION_LIBRARY
    [StackZone new];
#endif

#if !GNUSTEP_BASE_LIBRARY
    [NSPipe new];
    [NSTask new];
#endif

    __dummy();
}

