/* 
   objc.m

   Copyright (C) 1995, 1996, 1997 Ovidiu Predescu and Mircea Oancea.
   All rights reserved.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>

   This file is part of libFoundation.

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/

#include <stdio.h>
#include <extensions/objc-runtime.h>
#include "MyObject.h"

@protocol ProtocolTest1
- methodInProtocol1;
@end

@protocol ProtocolTest2 <ProtocolTest1>
- methodInProtocol2;
@end

@interface MyObject (Category) <ProtocolTest2>
- methodInCategory;
@end

@implementation MyObject (Category)
- methodInCategory
{
    puts(__FUNCTION__);
    return self;
}

- methodInProtocol1
{
    puts(__FUNCTION__);
    return self;
}

- methodInProtocol2
{
    puts(__FUNCTION__);
    return self;
}

- (int)checkProtocols
{
#if defined(NeXT) && GNU_RUNTIME == 1
    return 1;
#else
    return [@protocol(ProtocolTest2) conformsTo:@protocol(ProtocolTest1)];
#endif
}

@end

@interface NSObject (CheckRootMethods)
- (int)methodToRootClass;
@end

@implementation NSObject (CheckRootMethods)
- (int)methodToRootClass
{
    return 123;
}
@end


@interface ForwardingChecker : Forwarder
@end

@implementation ForwardingChecker

- (retval_t)forward:(SEL)selector:(arglist_t)argframe
{
    return objc_msg_sendv(object, selector, argframe);
}

@end
