/* 
   tests.h

   Copyright (C) 1995, 1996, 1997 Ovidiu Predescu and Mircea Oancea.
   All rights reserved.

   Author: Ovidiu Predescu <ovidiu@bx.logicnet.ro>

   This file is part of libFoundation.

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/

#ifndef __tests_h__
#define __tests_h__

#include <stdio.h>

enum {
    DO_NOTHING,
    FUNCTION_RETURN,
    EXCEPTION_BREAK,
    BREAK_LOOP,
    END_OF_INPUT
};

#define action \
    switch((ret = do_action())) { \
	case DO_NOTHING:	break; \
	case END_OF_INPUT: exit(0); \
	case FUNCTION_RETURN: puts("driver returned from " __FUNCTION__); return; \
    }

extern int do_action(void);

#endif /* __tests_h__ */
