/* 
   loop.m

   Copyright (C) 1995, 1996, 1997 Ovidiu Predescu and Mircea Oancea.
   All rights reserved.

   Author: Ovidiu Predescu <ovidiu@net-community.com>

   This file is part of libFoundation.

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/

#include <Foundation/NSException.h>

#include "tests.h"

void loop(void)
{
#if NX_CURRENT_COMPILER_RELEASE
# define __FUNCTION__ "loop"
#endif
    int ret;

    puts(__FUNCTION__);

    while(1)
	action;

    puts("driver returned from " __FUNCTION__);
#if NX_CURRENT_COMPILER_RELEASE
# undef __FUNCTION__ loop
#endif
}

void try_catch(void)
{
#if NX_CURRENT_COMPILER_RELEASE
# define __FUNCTION__ "try_catch"
#endif

    int ret = -1;

    puts(__FUNCTION__);

    NS_DURING {
	while(1) {
	    ret = do_action();
	    if(ret == BREAK_LOOP)
		break;
	    else if(ret == END_OF_INPUT)
		exit(0);
	}
    }
    NS_HANDLER {
	printf("caught exception %lu\n", (unsigned long)localException);
	while(1) {
	    ret = do_action();
	    if(ret == BREAK_LOOP)
		break;
	    else if(ret == END_OF_INPUT)
		exit(0);
	}
    }
    NS_ENDHANDLER;
	
    puts("driver returned from " __FUNCTION__);

#if NX_CURRENT_COMPILER_RELEASE
# undef __FUNCTION__
#endif
}
